library NicoDIPS;

{$R *.RES}

uses
  Windows, Messages, Commctrl;

const
  RegistryPfad: PChar = 'Software\Nico\DIPS';
  SpeichernStr: PChar = 'NicoDIPSsaveCommand';
  WiederherStr: PChar = 'NicoDIPSrestCommand';

var
  SpeichernCID: DWORD;
  WiederherCID: DWORD;
  ZumErstenMal: BOOL = True;
  GMHookHandle: DWORD;
  FensterThrID: DWORD;
  FensterThHnd: DWORD;
  TNicoDIPSform : TWndClass = (style: CS_OWNDC;
                               lpszClassName: 'TNicoDIPSform');
  NicoDIPSform: TCreateStruct = (cy: 100;
                                 cx: 100;
                                 y: -100;
                                 x: -100;
                                 style: WS_OVERLAPPEDWINDOW;
                                 lpszName: 'NicoDIPSform');
  NicoDIPSform_FHandle: DWORD;
  NicoDIPSform_Message: TMsg;
  NicoDIPSform_MResult: DWORD;

procedure NicoDIPSsave(wnd: HWND);
var
  cItems: Integer;
  bRegOK: Integer;
  hRgKey: HKEY;
  iLoopI: Integer;
  LVItem: TLVItem;
  aIText: array[0..MAX_PATH]of Char;
  ptIPos: TPoint;
begin
  hRgKey := 0;
  cItems := SendMessage(wnd, LVM_GETITEMCOUNT, 0, 0);
  RegDeleteKey(HKEY_CURRENT_USER, RegistryPfad);
  bRegOK := RegCreateKeyEx(HKEY_CURRENT_USER, RegistryPfad, 0, nil,
                           REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, nil, hRgKey,
                           nil);
  if bRegOK = ERROR_SUCCESS then
  begin
    iLoopI := 0;
    while iLoopI < cItems do
    begin
      ZeroMemory(@LVItem, SizeOf(LVItem));
      LVItem.pszText := @aIText[0];
      LVItem.cchTextMax := MAX_PATH;
      SendMessage(wnd, LVM_GETITEMTEXT, iLoopI, Integer(@LVItem));
      SendMessage(wnd, LVM_GETITEMPOSITION, iLoopI, Integer(@ptIPos));
      RegSetValueEx(hRgKey, LVItem.pszText, 0, REG_BINARY, @ptIPos,
                    DWORD(SizeOf(ptIPos)));
      Inc(iLoopI);
    end;
    RegCloseKey(hRgKey);
  end;
end;

procedure NicoDIPSrest(wnd: HWND);
var
  hRgKey: HKEY;
  bRegOK: Integer;
  iStyle: Integer;
  iLoopI: DWORD;
  aVName: array[0..MAX_PATH]of Char;
  nBytes: DWORD;
  ptIPos: TPoint;
  rgSize: DWORD;
  fIndex: Integer;
  rgType: DWORD;
  LVInfo: TLVFindInfo;
begin
  hRgKey := 0;
  bRegOK := RegOpenKeyEx(HKEY_CURRENT_USER, RegistryPfad, 0, KEY_QUERY_VALUE,
                         hRgKey);
  if bRegOK = ERROR_SUCCESS then
  begin
    iStyle := GetWindowLong(wnd, GWL_STYLE);
    if (iStyle and LVS_AUTOARRANGE <> 0) then
    begin
      SetWindowLong(wnd, GWL_STYLE, iStyle and not LVS_AUTOARRANGE);
    end;
    bRegOK := NO_ERROR;
    iLoopI := 0;
    while (bRegOK <> ERROR_NO_MORE_ITEMS) do
    begin
      nBytes := MAX_PATH;
      rgSize := DWORD(SizeOf(ptIPos));
      rgType := 0;
      bRegOK := RegEnumValue(hRgKey, iLoopI, aVName, nBytes, nil, @rgType,
                             PByte(@ptIPos), @rgSize);
      if bRegOK = ERROR_NO_MORE_ITEMS then Break;
      if (rgType = REG_BINARY) and (rgSize = DWORD(SizeOf(ptIPos))) then
      begin
        ZeroMemory(@LVInfo, DWORD(SizeOf(LVInfo)));
        LVInfo.flags := LVFI_STRING;
        LVInfo.psz := aVName;
        fIndex := SendMessage(wnd, LVM_FINDITEM, -1, Integer(@LVInfo));
        if fIndex <> -1 then
          SendMessage(wnd, LVM_SETITEMPOSITION, fIndex,
                      ptIPos.x or (ptIPos.y shl 16));
      end;
      Inc(iLoopI);
    end;
    SetWindowLong(wnd, GWL_STYLE, iStyle);
    RegCloseKey(hRgKey);
  end;
end;

function NicoDIPSformmsg(wnd: HWND; msg: UINT; wpara: WPARAM;
                         lpara: LPARAM): LRESULT; stdcall;
begin
  Result := Ord(True);
  case msg of
    WM_CREATE: Result := 0;
    WM_DESTROY: PostQuitMessage(0);
    else
    begin
      if msg = SpeichernCID then
      begin
        NicoDIPSsave(HWND(lpara))
      end
      else
      begin
        if msg = WiederherCID then
        begin
          NicoDIPSrest(HWND(lpara))
        end
        else
        begin
          Result := DefWindowProc(wnd, msg, wpara, lpara);
        end;
      end;
    end;
  end;
end;

function NicoDIPSmain(param: Pointer): DWORD; stdcall;
begin
  Result := Ord(True);
  TNicoDIPSform.lpfnWndProc := @NicoDIPSformmsg;
  TNicoDIPSform.hInstance := HInstance;
  if RegisterClass(TNicoDIPSform) <> 0 then
  begin
    NicoDIPSform.hInstance := TNicoDIPSform.hInstance;
    NicoDIPSform.lpszClass := TNicoDIPSform.lpszClassName;
    NicoDIPSform_FHandle := CreateWindow(NicoDIPSform.lpszClass,
                                         NicoDIPSform.lpszName,
                                         NicoDIPSform.style,
                                         NicoDIPSform.x, NicoDIPSform.y,
                                         NicoDIPSform.cx, NicoDIPSform.cy,
                                         0, 0, NicoDIPSform.hInstance,
                                         NicoDIPSform.lpCreateParams);
    if NicoDIPSform_FHandle <> 0 then
    begin
      repeat
        NicoDIPSform_MResult := DWORD(GetMessage(NicoDIPSform_Message,
                                      NicoDIPSform_FHandle, 0, 0));
        case NicoDIPSform_MResult of
          0, DWORD(-1): Break;
          else
          begin
            TranslateMessage(NicoDIPSform_Message);
            DispatchMessage(NicoDIPSform_Message);
          end;
        end;
      until False;
    end;
    UnregisterClass(TNicoDIPSform.lpszClassName, NicoDIPSform.hInstance);
  end;
end;

function NicoDIPSmessage(code: Integer; wpara: WPARAM;
                         lpara: LPARAM): LRESULT stdcall;
begin
  if (ZumErstenMal) then
  begin
    ZumErstenMal := False;
    FensterThHnd := CreateThread(nil, 0, @NicoDIPSmain, nil, 0, FensterThrID);
  end;
  Result := CallNextHookEx(0, code, wpara, lpara);
end;

function NicoDIPSinstall(ThreadID: Cardinal): BOOL;
begin
  Result := False;
  if (ThreadID <> 0) and (GMHookHandle = 0) then
  begin
    GMHookHandle := SetWindowsHookEx(WH_GETMESSAGE, NicoDIPSmessage,
                                     HInstance, ThreadID);
    Result := GMHookHandle <> 0;
  end;
end;

function NicoDIPSrelease: BOOL;
begin
  Result := False;
  if GMHookHandle <> 0 then
  begin
    Result := UnhookWindowsHookEx(GMHookHandle);
  end;
end;

procedure DllMain(Reason: Cardinal);
begin
  case Reason of
    DLL_PROCESS_ATTACH:
    begin
      DisableThreadLibraryCalls(HInstance);
      SpeichernCID := RegisterWindowMessage(SpeichernStr);
      WiederherCID := RegisterWindowMessage(WiederherStr);
    end;
    DLL_PROCESS_DETACH:
    begin
      if FensterThHnd <> 0 then
      begin
        SendMessage(NicoDIPSform_FHandle, WM_CLOSE, 0, 0);
        TerminateThread(FensterThHnd, 0);
        CloseHandle(FensterThHnd);
      end;
    end;
  end;
end;

exports
  NicoDIPSinstall index 1 name 'NicoDIPSinstall',
  NicoDIPSrelease index 2 name 'NicoDIPSrelease';

begin
  DllProc := @DllMain;
  DllMain(DLL_PROCESS_ATTACH);
end.

